(require 'cc-mode)

(defun myown-c-mode-common-hook()
 (defconst myown-c-style '( "MYOWN"
  (c-basic-offset . 3)
  (c-tab-always-indent . t)
  (c-offsets-alist .
   ((c . 0)
    (label . 0)
    (string . +)
    (defun-open . +)
    (defun-block-intro . 0)
    (defun-close . 0)
    (block-open . +)
    (block-close . 0)
    (statement . 0)
    (statement-cont . c-lineup-math)
    (statement-block-intro . 0)
    (statement-case-open . +)
    (statement-case-intro . +)
    (case-label . 0)
    (substatement . +)
    (substatement-open . +)
    (else-clause . 0)
    (do-while-closure . 0)
    (arglist-intro . c-lineup-arglist-intro-after-paren)
    (arglist-cont . 0)
    (arglist-cont-nonempty . c-lineup-arglist)
    (arglist-close . 0)
    (brace-list-open . +)
    (brace-list-intro . 0)
    (brace-list-entry . 0)
    (brace-list-close . 0)
    (topmost-intro . 0)
    (topmost-intro-cont . 0)
    (class-open . +)
    (inher-intro . +)
    (inher-cont . c-lineup-multi-inher)
    (member-init-intro . +)
    (member-init-cont . 0)
    (access-label . +)
    (inclass . 0)
    (inline-open . ++)
    (inline-close . 0)
    (friend . 0)
    (class-close . +)
    (stream-op . c-lineup-streamop)
    (comment-intro . c-lineup-comment)
    (cpp-macro . -1000))))
  "my own c-style")
 (let ((myown-c-style-tags "MYOWN"))
  (or (assoc myown-c-style-tags c-style-alist)
   (setq c-style-alist (cons myown-c-style c-style-alist)))
  (c-set-style myown-c-style-tags))
 (setq tab-width 8)
 (setq indent-tabs-mode nil)
 (local-set-key "{" 'self-insert-command)
 (local-set-key "+" 'self-insert-command)
 (local-set-key "-" 'self-insert-command)
 (local-set-key "*" 'self-insert-command)
 (local-set-key "/" 'self-insert-command)
 (local-set-key "," 'self-insert-command)
 (local-set-key ":" 'self-insert-command)
 (local-set-key ";" 'self-insert-command)
 (local-set-key "<" 'self-insert-command)
 (local-set-key ">" 'self-insert-command)
 (local-set-key "(" 'self-insert-command)
 (local-set-key ")" 'self-insert-command)
 (local-set-key "\C-m" 'newline-and-indent)
 (local-set-key "}" 'self-insert-command))

(defun roettger-enable-myown-c-mode()
 "enable my own c-mode"
 (interactive)
 (add-hook 'c-mode-common-hook 'myown-c-mode-common-hook t)
 (message "enabled my own c-mode"))

(defun roettger-disable-myown-c-mode()
 "disable my own c-mode"
 (interactive)
 (remove-hook 'c-mode-common-hook 'myown-c-mode-common-hook)
 (setq c-basic-offset 3)
 (message "disabled my own c-mode"))

(defun roettger-set-basic-offset(offset)
 "set basic offset"
 (interactive "p")
 (if (= offset 1) (setq offset 3))
 (if (= offset 0) (setq offset 1))
 (setq c-basic-offset offset))

(global-set-key [M-C-n] 'roettger-enable-myown-c-mode)
(global-set-key [M-C-b] 'roettger-disable-myown-c-mode)
(global-set-key [M-C-backspace] 'roettger-disable-myown-c-mode)
(global-set-key [M-C-v] 'roettger-set-basic-offset)

(provide 'myown-c-mode)
